<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>Advanced Cuts for Cooperative OPF: decoop::PlantbusSubproblemCW Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Advanced Cuts for Cooperative OPF
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Friends</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedecoop.html">decoop</a></li><li class="navelem"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html">PlantbusSubproblemCW</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdecoop_1_1_plantbus_subproblem_c_w-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">decoop::PlantbusSubproblemCW Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Provides an interface for solving CW subproblems and adding cuts from such problems.  
 <a href="classdecoop_1_1_plantbus_subproblem_c_w.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="coop_benders_subproblem_c_w_8hpp_source.html">coopBendersSubproblemCW.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aa3c0b8800ac33bd051f94b56a302183f"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aa3c0b8800ac33bd051f94b56a302183f">PlantbusSubproblemCW</a> (const GRBEnv &amp;env, const std::string &amp;option_path, const double plant_load, const unsigned num_timesteps)</td></tr>
<tr class="memdesc:aa3c0b8800ac33bd051f94b56a302183f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#aa3c0b8800ac33bd051f94b56a302183f">More...</a><br/></td></tr>
<tr class="separator:aa3c0b8800ac33bd051f94b56a302183f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae71d6b0c1a18c8e31c45235a4a1f6b84"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae71d6b0c1a18c8e31c45235a4a1f6b84"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ae71d6b0c1a18c8e31c45235a4a1f6b84">Solve</a> ()</td></tr>
<tr class="memdesc:ae71d6b0c1a18c8e31c45235a4a1f6b84"><td class="mdescLeft">&#160;</td><td class="mdescRight">Solves the subproblem with the currently held power profile suggestion and corepoint. <br/></td></tr>
<tr class="separator:ae71d6b0c1a18c8e31c45235a4a1f6b84"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae8279974b7182bbd519f8385924fac33"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ae8279974b7182bbd519f8385924fac33">UpdateCorepoint</a> (const unsigned key, const double new_corepoint)</td></tr>
<tr class="memdesc:ae8279974b7182bbd519f8385924fac33"><td class="mdescLeft">&#160;</td><td class="mdescRight">Update a single entry in the <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a91f5690237483f342b41e361b6d46cd5" title="Corepoint used to generate cuts. Unit is multiples of flexible load. ">corepoint_</a> vector.  <a href="#ae8279974b7182bbd519f8385924fac33">More...</a><br/></td></tr>
<tr class="separator:ae8279974b7182bbd519f8385924fac33"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a69065f486b0ac29be6db34f5c784f43b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a69065f486b0ac29be6db34f5c784f43b">UpdateCorepoint</a> (const std::vector&lt; double &gt; &amp;new_corepoints)</td></tr>
<tr class="memdesc:a69065f486b0ac29be6db34f5c784f43b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Update the <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a91f5690237483f342b41e361b6d46cd5" title="Corepoint used to generate cuts. Unit is multiples of flexible load. ">corepoint_</a> vector.  <a href="#a69065f486b0ac29be6db34f5c784f43b">More...</a><br/></td></tr>
<tr class="separator:a69065f486b0ac29be6db34f5c784f43b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a06f49aeddff2c1981a3a231c549b8000"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a06f49aeddff2c1981a3a231c549b8000">GetModelStatus</a> () const </td></tr>
<tr class="memdesc:a06f49aeddff2c1981a3a231c549b8000"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns status code of the <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad7e12446fa7a1824dd12803d1e6534ab" title="CW subproblem model. ">model_</a>. See Gurobi reference manual for meaning of codes.  <a href="#a06f49aeddff2c1981a3a231c549b8000">More...</a><br/></td></tr>
<tr class="separator:a06f49aeddff2c1981a3a231c549b8000"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4fcbf5d97b156d8ee4031ea96c0c7af5"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a4fcbf5d97b156d8ee4031ea96c0c7af5">GetNewRhs</a> () const </td></tr>
<tr class="memdesc:a4fcbf5d97b156d8ee4031ea96c0c7af5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes right hand side of the cut generated from current power profile suggestion.  <a href="#a4fcbf5d97b156d8ee4031ea96c0c7af5">More...</a><br/></td></tr>
<tr class="separator:a4fcbf5d97b156d8ee4031ea96c0c7af5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2d5561f12e79233e48339c1c2bac1caf"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a2d5561f12e79233e48339c1c2bac1caf">GetCurrLhs</a> () const </td></tr>
<tr class="memdesc:a2d5561f12e79233e48339c1c2bac1caf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes value of the left hand side of the generated cut when current power profile suggestion is inserted.  <a href="#a2d5561f12e79233e48339c1c2bac1caf">More...</a><br/></td></tr>
<tr class="separator:a2d5561f12e79233e48339c1c2bac1caf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa890c1d64806136f001992e4eaffb703"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aa890c1d64806136f001992e4eaffb703">GetNewCoeff</a> (const unsigned key) const </td></tr>
<tr class="memdesc:aa890c1d64806136f001992e4eaffb703"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes coefficient of the left hand side of the cut for a given timestep.  <a href="#aa890c1d64806136f001992e4eaffb703">More...</a><br/></td></tr>
<tr class="separator:aa890c1d64806136f001992e4eaffb703"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab500692dcfb4bdb1c3fc11907356cb0f"><td class="memItemLeft" align="right" valign="top">std::vector&lt; double &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ab500692dcfb4bdb1c3fc11907356cb0f">GetNewCoeffs</a> () const </td></tr>
<tr class="memdesc:ab500692dcfb4bdb1c3fc11907356cb0f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes all coefficients of the left hand side of the cut.  <a href="#ab500692dcfb4bdb1c3fc11907356cb0f">More...</a><br/></td></tr>
<tr class="separator:ab500692dcfb4bdb1c3fc11907356cb0f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5e02745359b70d8f9f65d14bf6926244"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a5e02745359b70d8f9f65d14bf6926244">GetSubproblemObjective</a> () const </td></tr>
<tr class="memdesc:a5e02745359b70d8f9f65d14bf6926244"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns objective value of the <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad7e12446fa7a1824dd12803d1e6534ab" title="CW subproblem model. ">model_</a>.  <a href="#a5e02745359b70d8f9f65d14bf6926244">More...</a><br/></td></tr>
<tr class="separator:a5e02745359b70d8f9f65d14bf6926244"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a478d2508e1a163bca9baf99db8539d"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a7a478d2508e1a163bca9baf99db8539d">GenerateAndVerifyCut</a> () const </td></tr>
<tr class="memdesc:a7a478d2508e1a163bca9baf99db8539d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes right hand side of the cut and ensures that current power profile suggestion is cut off.  <a href="#a7a478d2508e1a163bca9baf99db8539d">More...</a><br/></td></tr>
<tr class="separator:a7a478d2508e1a163bca9baf99db8539d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a447b774cba6493024db2f58dd7258907"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a447b774cba6493024db2f58dd7258907">get_plant_load</a> () const </td></tr>
<tr class="memdesc:a447b774cba6493024db2f58dd7258907"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns flexible load of this subproblem in MW.  <a href="#a447b774cba6493024db2f58dd7258907">More...</a><br/></td></tr>
<tr class="separator:a447b774cba6493024db2f58dd7258907"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9afee3d671f727efb530ff3772d2b77"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ae9afee3d671f727efb530ff3772d2b77">ComputeFeasDistance</a> () const </td></tr>
<tr class="memdesc:ae9afee3d671f727efb530ff3772d2b77"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes distance between suggested power profile and the feasible profile found by the subproblem. Unit is MW.  <a href="#ae9afee3d671f727efb530ff3772d2b77">More...</a><br/></td></tr>
<tr class="separator:ae9afee3d671f727efb530ff3772d2b77"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af3205ee08bd2a494b33820d612b7b5ba"><td class="memItemLeft" align="right" valign="top">std::vector&lt; double &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#af3205ee08bd2a494b33820d612b7b5ba">ComputeFeasSol</a> () const </td></tr>
<tr class="memdesc:af3205ee08bd2a494b33820d612b7b5ba"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes the feasible power profile found by the subproblem. Unit is MW.  <a href="#af3205ee08bd2a494b33820d612b7b5ba">More...</a><br/></td></tr>
<tr class="separator:af3205ee08bd2a494b33820d612b7b5ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8c5121e208bb21fa0c52cf784514419b"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a8c5121e208bb21fa0c52cf784514419b">ComputeFeasSol</a> (const unsigned key) const </td></tr>
<tr class="memdesc:a8c5121e208bb21fa0c52cf784514419b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes entry of the feasible power profile at given timestep found by the subproblem. Unit is MW.  <a href="#a8c5121e208bb21fa0c52cf784514419b">More...</a><br/></td></tr>
<tr class="separator:a8c5121e208bb21fa0c52cf784514419b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3f42075cda7f69096355045d648c4599"><td class="memItemLeft" align="right" valign="top">std::vector&lt; double &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a3f42075cda7f69096355045d648c4599">get_pow_sugg</a> () const </td></tr>
<tr class="memdesc:a3f42075cda7f69096355045d648c4599"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns power profile suggestion. Unit is multiples of flexible load.  <a href="#a3f42075cda7f69096355045d648c4599">More...</a><br/></td></tr>
<tr class="separator:a3f42075cda7f69096355045d648c4599"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a058e9ac14a3ca2307517d5b241767b15"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a058e9ac14a3ca2307517d5b241767b15">get_pow_sugg</a> (const unsigned i) const </td></tr>
<tr class="memdesc:a058e9ac14a3ca2307517d5b241767b15"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns entry of the power profile suggestion at a given timestep. Unit is multiples of flexible load.  <a href="#a058e9ac14a3ca2307517d5b241767b15">More...</a><br/></td></tr>
<tr class="separator:a058e9ac14a3ca2307517d5b241767b15"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afbf4b8dc57126920f32ad67adb84af8e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#afbf4b8dc57126920f32ad67adb84af8e">set_pow_sugg</a> (const std::vector&lt; double &gt; &amp;in)</td></tr>
<tr class="memdesc:afbf4b8dc57126920f32ad67adb84af8e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets power profile suggestion.  <a href="#afbf4b8dc57126920f32ad67adb84af8e">More...</a><br/></td></tr>
<tr class="separator:afbf4b8dc57126920f32ad67adb84af8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a00e9f179a658861304dc1bfa6a9bb62d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a00e9f179a658861304dc1bfa6a9bb62d">set_pow_sugg</a> (const unsigned key, const double val)</td></tr>
<tr class="memdesc:a00e9f179a658861304dc1bfa6a9bb62d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets power suggestion at single timestep.  <a href="#a00e9f179a658861304dc1bfa6a9bb62d">More...</a><br/></td></tr>
<tr class="separator:a00e9f179a658861304dc1bfa6a9bb62d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a64c81ab64caab70f9c6aff7f5bb64a3b"><td class="memItemLeft" align="right" valign="top">GRBModel &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a64c81ab64caab70f9c6aff7f5bb64a3b">GetModel</a> ()</td></tr>
<tr class="memdesc:a64c81ab64caab70f9c6aff7f5bb64a3b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns reference to <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad7e12446fa7a1824dd12803d1e6534ab" title="CW subproblem model. ">model_</a> object.  <a href="#a64c81ab64caab70f9c6aff7f5bb64a3b">More...</a><br/></td></tr>
<tr class="separator:a64c81ab64caab70f9c6aff7f5bb64a3b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:ae2779d2f3712e01095a5d16b83964942"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ae2779d2f3712e01095a5d16b83964942">InitObject</a> ()</td></tr>
<tr class="memdesc:ae2779d2f3712e01095a5d16b83964942"><td class="mdescLeft">&#160;</td><td class="mdescRight">Fills <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a5fd86f8e5255a5a93ae8a2020909cf0f" title="Indices of the equations in equations_ that represent the coupling equation (1 entry per timestep)...">coupling_equation_</a>, <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a899358e94d997203250bad1b94e20e54" title="Indices of all entries in equations_ that are not a coupling equation. ">constraints_</a>, <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aac4daea3f91b964dd81e2b80ec15cde9" title="Indices of all entries in variables_ that are part of the plant model. ">model_vars_</a> and <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aaf7b1f8a23f5b45aa865450477990f68" title="Index of the objective variable in variables_. ">lambda_index_</a>.  <a href="#ae2779d2f3712e01095a5d16b83964942">More...</a><br/></td></tr>
<tr class="separator:ae2779d2f3712e01095a5d16b83964942"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:af48cb65d704614e369696498d709a18e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af48cb65d704614e369696498d709a18e"></a>
const <a class="el" href="structdecoop_1_1_subproblem_options.html">SubproblemOptions</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#af48cb65d704614e369696498d709a18e">options_</a></td></tr>
<tr class="memdesc:af48cb65d704614e369696498d709a18e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Holds options specified by user in option file. <br/></td></tr>
<tr class="separator:af48cb65d704614e369696498d709a18e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad7e12446fa7a1824dd12803d1e6534ab"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad7e12446fa7a1824dd12803d1e6534ab"></a>
GRBModel&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad7e12446fa7a1824dd12803d1e6534ab">model_</a></td></tr>
<tr class="memdesc:ad7e12446fa7a1824dd12803d1e6534ab"><td class="mdescLeft">&#160;</td><td class="mdescRight">CW subproblem model. <br/></td></tr>
<tr class="separator:ad7e12446fa7a1824dd12803d1e6534ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adbfb3166b1d79902135b0cce8b9b096d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="adbfb3166b1d79902135b0cce8b9b096d"></a>
<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a>&lt; GRBConstr &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#adbfb3166b1d79902135b0cce8b9b096d">equations_</a></td></tr>
<tr class="memdesc:adbfb3166b1d79902135b0cce8b9b096d"><td class="mdescLeft">&#160;</td><td class="mdescRight">All equations part of the <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad7e12446fa7a1824dd12803d1e6534ab" title="CW subproblem model. ">model_</a>. <br/></td></tr>
<tr class="separator:adbfb3166b1d79902135b0cce8b9b096d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aecdb6c3ea45c871f69081038fba5aa25"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aecdb6c3ea45c871f69081038fba5aa25"></a>
<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a>&lt; GRBVar &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aecdb6c3ea45c871f69081038fba5aa25">variables_</a></td></tr>
<tr class="memdesc:aecdb6c3ea45c871f69081038fba5aa25"><td class="mdescLeft">&#160;</td><td class="mdescRight">All variables part of the <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad7e12446fa7a1824dd12803d1e6534ab" title="CW subproblem model. ">model_</a>. <br/></td></tr>
<tr class="separator:aecdb6c3ea45c871f69081038fba5aa25"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af0fa8f272e5f8800a7bf532607739d93"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af0fa8f272e5f8800a7bf532607739d93"></a>
const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#af0fa8f272e5f8800a7bf532607739d93">coupling_equation_name_</a></td></tr>
<tr class="memdesc:af0fa8f272e5f8800a7bf532607739d93"><td class="mdescLeft">&#160;</td><td class="mdescRight">Name of the equation coupling master power suggestion and feasible profile computed in subproblem. <br/></td></tr>
<tr class="separator:af0fa8f272e5f8800a7bf532607739d93"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5fd86f8e5255a5a93ae8a2020909cf0f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5fd86f8e5255a5a93ae8a2020909cf0f"></a>
std::vector&lt; int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a5fd86f8e5255a5a93ae8a2020909cf0f">coupling_equation_</a></td></tr>
<tr class="memdesc:a5fd86f8e5255a5a93ae8a2020909cf0f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Indices of the equations in <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#adbfb3166b1d79902135b0cce8b9b096d" title="All equations part of the model_. ">equations_</a> that represent the coupling equation (1 entry per timestep). <br/></td></tr>
<tr class="separator:a5fd86f8e5255a5a93ae8a2020909cf0f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a899358e94d997203250bad1b94e20e54"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a899358e94d997203250bad1b94e20e54"></a>
std::vector&lt; int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a899358e94d997203250bad1b94e20e54">constraints_</a></td></tr>
<tr class="memdesc:a899358e94d997203250bad1b94e20e54"><td class="mdescLeft">&#160;</td><td class="mdescRight">Indices of all entries in <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#adbfb3166b1d79902135b0cce8b9b096d" title="All equations part of the model_. ">equations_</a> that are not a coupling equation. <br/></td></tr>
<tr class="separator:a899358e94d997203250bad1b94e20e54"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aac4daea3f91b964dd81e2b80ec15cde9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aac4daea3f91b964dd81e2b80ec15cde9"></a>
std::vector&lt; int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aac4daea3f91b964dd81e2b80ec15cde9">model_vars_</a></td></tr>
<tr class="memdesc:aac4daea3f91b964dd81e2b80ec15cde9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Indices of all entries in <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aecdb6c3ea45c871f69081038fba5aa25" title="All variables part of the model_. ">variables_</a> that are part of the plant model. <br/></td></tr>
<tr class="separator:aac4daea3f91b964dd81e2b80ec15cde9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad247ed38e4efce149d022550e0478c36"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad247ed38e4efce149d022550e0478c36"></a>
const unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad247ed38e4efce149d022550e0478c36">num_timesteps_</a></td></tr>
<tr class="memdesc:ad247ed38e4efce149d022550e0478c36"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of timesteps in the model. <br/></td></tr>
<tr class="separator:ad247ed38e4efce149d022550e0478c36"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad2e244d13adaf901ad358e8f695d29a1"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad2e244d13adaf901ad358e8f695d29a1"></a>
std::vector&lt; double &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad2e244d13adaf901ad358e8f695d29a1">pow_sugg_</a></td></tr>
<tr class="memdesc:ad2e244d13adaf901ad358e8f695d29a1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Power profile suggestion. Unit is multiples of flexible load. <br/></td></tr>
<tr class="separator:ad2e244d13adaf901ad358e8f695d29a1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a91f5690237483f342b41e361b6d46cd5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a91f5690237483f342b41e361b6d46cd5"></a>
std::vector&lt; double &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a91f5690237483f342b41e361b6d46cd5">corepoint_</a></td></tr>
<tr class="memdesc:a91f5690237483f342b41e361b6d46cd5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Corepoint used to generate cuts. Unit is multiples of flexible load. <br/></td></tr>
<tr class="separator:a91f5690237483f342b41e361b6d46cd5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ef5a600d1de8f464eed5d37a441f963"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3ef5a600d1de8f464eed5d37a441f963"></a>
const double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a3ef5a600d1de8f464eed5d37a441f963">plant_load_</a></td></tr>
<tr class="memdesc:a3ef5a600d1de8f464eed5d37a441f963"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flexible load of this subproblem in MW. <br/></td></tr>
<tr class="separator:a3ef5a600d1de8f464eed5d37a441f963"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a937a25c561ee3be032596ca30c90f4e7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a937a25c561ee3be032596ca30c90f4e7"></a>
const unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a937a25c561ee3be032596ca30c90f4e7">rhs_num_records_</a></td></tr>
<tr class="memdesc:a937a25c561ee3be032596ca30c90f4e7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of terms used to compute scalar product on right hand side of a cut. <br/></td></tr>
<tr class="separator:a937a25c561ee3be032596ca30c90f4e7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaf7b1f8a23f5b45aa865450477990f68"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aaf7b1f8a23f5b45aa865450477990f68"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aaf7b1f8a23f5b45aa865450477990f68">lambda_index_</a></td></tr>
<tr class="memdesc:aaf7b1f8a23f5b45aa865450477990f68"><td class="mdescLeft">&#160;</td><td class="mdescRight">Index of the objective variable in <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aecdb6c3ea45c871f69081038fba5aa25" title="All variables part of the model_. ">variables_</a>. <br/></td></tr>
<tr class="separator:aaf7b1f8a23f5b45aa865450477990f68"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Provides an interface for solving CW subproblems and adding cuts from such problems. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="aa3c0b8800ac33bd051f94b56a302183f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">decoop::PlantbusSubproblemCW::PlantbusSubproblemCW </td>
          <td>(</td>
          <td class="paramtype">const GRBEnv &amp;&#160;</td>
          <td class="paramname"><em>env</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>option_path</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const double&#160;</td>
          <td class="paramname"><em>plant_load</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned&#160;</td>
          <td class="paramname"><em>num_timesteps</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">env</td><td>Reference to the Gurobi environment in which to construct the <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad7e12446fa7a1824dd12803d1e6534ab" title="CW subproblem model. ">model_</a>. </td></tr>
    <tr><td class="paramname">option_path</td><td>String containing the path to the option file directory. </td></tr>
    <tr><td class="paramname">plant_load</td><td>Flexible load of this subproblem in MW. </td></tr>
    <tr><td class="paramname">num_timesteps</td><td>Number of timesteps in the model. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="ae9afee3d671f727efb530ff3772d2b77"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemCW::ComputeFeasDistance </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes distance between suggested power profile and the feasible profile found by the subproblem. Unit is MW. </p>
<dl class="section return"><dt>Returns</dt><dd>Distance to feasible power profile. </dd></dl>

</div>
</div>
<a class="anchor" id="af3205ee08bd2a494b33820d612b7b5ba"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; double &gt; decoop::PlantbusSubproblemCW::ComputeFeasSol </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes the feasible power profile found by the subproblem. Unit is MW. </p>
<dl class="section return"><dt>Returns</dt><dd>Feasible power profile. </dd></dl>

</div>
</div>
<a class="anchor" id="a8c5121e208bb21fa0c52cf784514419b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemCW::ComputeFeasSol </td>
          <td>(</td>
          <td class="paramtype">const unsigned&#160;</td>
          <td class="paramname"><em>key</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes entry of the feasible power profile at given timestep found by the subproblem. Unit is MW. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>Timestep of the feasible power entry. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Feasible power entry at given timestep. </dd></dl>

</div>
</div>
<a class="anchor" id="a7a478d2508e1a163bca9baf99db8539d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemCW::GenerateAndVerifyCut </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes right hand side of the cut and ensures that current power profile suggestion is cut off. </p>
<dl class="section return"><dt>Returns</dt><dd>Right hand side of the cut. </dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classdecoop_1_1_irrelevant_cut_exception.html" title="Execption class for irrelevant cuts. ">IrrelevantCutException</a></td><td>is thrown if the current power profile suggestion is not cut off. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a447b774cba6493024db2f58dd7258907"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemCW::get_plant_load </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns flexible load of this subproblem in MW. </p>
<dl class="section return"><dt>Returns</dt><dd>Flexible load of this subproblem. </dd></dl>

</div>
</div>
<a class="anchor" id="a3f42075cda7f69096355045d648c4599"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; double &gt; decoop::PlantbusSubproblemCW::get_pow_sugg </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns power profile suggestion. Unit is multiples of flexible load. </p>
<dl class="section return"><dt>Returns</dt><dd>Power profile suggestion. </dd></dl>

</div>
</div>
<a class="anchor" id="a058e9ac14a3ca2307517d5b241767b15"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemCW::get_pow_sugg </td>
          <td>(</td>
          <td class="paramtype">const unsigned&#160;</td>
          <td class="paramname"><em>i</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns entry of the power profile suggestion at a given timestep. Unit is multiples of flexible load. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">i</td><td>Timestep of power suggestion entry. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Power suggestion at given timestep. </dd></dl>

</div>
</div>
<a class="anchor" id="a2d5561f12e79233e48339c1c2bac1caf"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemCW::GetCurrLhs </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes value of the left hand side of the generated cut when current power profile suggestion is inserted. </p>
<dl class="section return"><dt>Returns</dt><dd>Value of left hand side of the cut. </dd></dl>

</div>
</div>
<a class="anchor" id="a64c81ab64caab70f9c6aff7f5bb64a3b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">GRBModel &amp; decoop::PlantbusSubproblemCW::GetModel </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns reference to <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad7e12446fa7a1824dd12803d1e6534ab" title="CW subproblem model. ">model_</a> object. </p>
<dl class="section return"><dt>Returns</dt><dd>Reference to model. </dd></dl>

</div>
</div>
<a class="anchor" id="a06f49aeddff2c1981a3a231c549b8000"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int decoop::PlantbusSubproblemCW::GetModelStatus </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns status code of the <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad7e12446fa7a1824dd12803d1e6534ab" title="CW subproblem model. ">model_</a>. See Gurobi reference manual for meaning of codes. </p>
<dl class="section return"><dt>Returns</dt><dd>Model status code. </dd></dl>

</div>
</div>
<a class="anchor" id="aa890c1d64806136f001992e4eaffb703"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemCW::GetNewCoeff </td>
          <td>(</td>
          <td class="paramtype">const unsigned&#160;</td>
          <td class="paramname"><em>key</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes coefficient of the left hand side of the cut for a given timestep. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>Timestep for which the coefficient is to be calculated. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Coefficient at given timestep. </dd></dl>

</div>
</div>
<a class="anchor" id="ab500692dcfb4bdb1c3fc11907356cb0f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; double &gt; decoop::PlantbusSubproblemCW::GetNewCoeffs </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes all coefficients of the left hand side of the cut. </p>
<dl class="section return"><dt>Returns</dt><dd>Vector holding all coefficients. </dd></dl>

</div>
</div>
<a class="anchor" id="a4fcbf5d97b156d8ee4031ea96c0c7af5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemCW::GetNewRhs </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes right hand side of the cut generated from current power profile suggestion. </p>
<dl class="section return"><dt>Returns</dt><dd>Right hand side of the cut.</dd></dl>
<p>Implementation currently does not check the model status here, so calling this without ensuring the model has been solved may result in an exception thrown by Gurobi. </p>

</div>
</div>
<a class="anchor" id="a5e02745359b70d8f9f65d14bf6926244"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemCW::GetSubproblemObjective </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns objective value of the <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad7e12446fa7a1824dd12803d1e6534ab" title="CW subproblem model. ">model_</a>. </p>
<p>Objective value should be between 0 (power suggestion is feasible) and 1. The value indicates the factor of the corepoint in a feasible convex combination of corepoint and power suggestion. p_feas = lambda * corepoint + (1-lambda) * p_sugg. </p>
<dl class="section return"><dt>Returns</dt><dd>Objective value. </dd></dl>

</div>
</div>
<a class="anchor" id="ae2779d2f3712e01095a5d16b83964942"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long decoop::PlantbusSubproblemCW::InitObject </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Fills <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a5fd86f8e5255a5a93ae8a2020909cf0f" title="Indices of the equations in equations_ that represent the coupling equation (1 entry per timestep)...">coupling_equation_</a>, <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a899358e94d997203250bad1b94e20e54" title="Indices of all entries in equations_ that are not a coupling equation. ">constraints_</a>, <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aac4daea3f91b964dd81e2b80ec15cde9" title="Indices of all entries in variables_ that are part of the plant model. ">model_vars_</a> and <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aaf7b1f8a23f5b45aa865450477990f68" title="Index of the objective variable in variables_. ">lambda_index_</a>. </p>
<dl class="section return"><dt>Returns</dt><dd>Sum of sizes of <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a899358e94d997203250bad1b94e20e54" title="Indices of all entries in equations_ that are not a coupling equation. ">constraints_</a> and <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aac4daea3f91b964dd81e2b80ec15cde9" title="Indices of all entries in variables_ that are part of the plant model. ">model_vars_</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="afbf4b8dc57126920f32ad67adb84af8e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void decoop::PlantbusSubproblemCW::set_pow_sugg </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; double &gt; &amp;&#160;</td>
          <td class="paramname"><em>in</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sets power profile suggestion. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>Reference to vector containing the new power profile suggestion. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a00e9f179a658861304dc1bfa6a9bb62d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void decoop::PlantbusSubproblemCW::set_pow_sugg </td>
          <td>(</td>
          <td class="paramtype">const unsigned&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const double&#160;</td>
          <td class="paramname"><em>val</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sets power suggestion at single timestep. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>Timestep to set power suggestion at. </td></tr>
    <tr><td class="paramname">val</td><td>Power suggestion. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae8279974b7182bbd519f8385924fac33"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void decoop::PlantbusSubproblemCW::UpdateCorepoint </td>
          <td>(</td>
          <td class="paramtype">const unsigned&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const double&#160;</td>
          <td class="paramname"><em>new_corepoint</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Update a single entry in the <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a91f5690237483f342b41e361b6d46cd5" title="Corepoint used to generate cuts. Unit is multiples of flexible load. ">corepoint_</a> vector. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>Index to update. </td></tr>
    <tr><td class="paramname">new_corepoint</td><td>New value. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a69065f486b0ac29be6db34f5c784f43b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void decoop::PlantbusSubproblemCW::UpdateCorepoint </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; double &gt; &amp;&#160;</td>
          <td class="paramname"><em>new_corepoints</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Update the <a class="el" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a91f5690237483f342b41e361b6d46cd5" title="Corepoint used to generate cuts. Unit is multiples of flexible load. ">corepoint_</a> vector. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">new_corepoints</td><td>Reference to vector holding the new values. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>inc/<a class="el" href="coop_benders_subproblem_c_w_8hpp_source.html">coopBendersSubproblemCW.hpp</a></li>
<li>src/<a class="el" href="coop_benders_subproblem_c_w_8cpp.html">coopBendersSubproblemCW.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.5
</small></address>
</body>
</html>
